#include <stdarg.h>
#include <stdio.h>
#include <cv.h>
#include <highgui.h>

///////////////////////////////////
IplImage *red;
IplImage *green;
IplImage *blue;
IplImage *mask;
CvHistogram *rhist;
CvHistogram *ghist;
CvHistogram *bhist;

int cal_hist(IplImage * input_image);

int main(int Count, char *Strings[])
{  
   IplImage *input_image = cvLoadImage("v200.jpg", 1);
   int width = 320;
   int height = 240;
   red = cvCreateImage(cvSize(width,height), IPL_DEPTH_8U, 1);
   green = cvCreateImage(cvSize(width,height), IPL_DEPTH_8U, 1);
   blue = cvCreateImage(cvSize(width,height), IPL_DEPTH_8U, 1);
   mask = cvCreateImage( cvSize(width,height), IPL_DEPTH_8U, 1 );

    CvScalar s;

    for(int n = 0; n < height; n++)
    for(int m = 0; m < width; m++)
    {
       s.val[0]= 255;
       cvSet2D(mask,n,m,s);
    }

   int hdims = 32;
   float hranges_arr[] = {0, 255};
   float* hranges = hranges_arr;

   rhist = cvCreateHist( 1, &hdims, CV_HIST_ARRAY, &hranges, 1 );
   ghist = cvCreateHist( 1, &hdims, CV_HIST_ARRAY, &hranges, 1 );
   hdims = 16;
   bhist = cvCreateHist( 1, &hdims, CV_HIST_ARRAY, &hranges, 1 );

   cal_hist(input_image);
   
   cvReleaseImage(&input_image);
   cvReleaseImage(&mask);
   cvReleaseImage(&red);
   cvReleaseImage(&green);
   cvReleaseImage(&blue);
   cvReleaseHist(&rhist);
   cvReleaseHist(&ghist);
   cvReleaseHist(&bhist);
   return 0;
}


int cal_hist(IplImage * input_image)
{

        cvSplit( input_image, red, green, blue, 0 );
        char fname[200];
        sprintf(fname, "objects_info_1.txt");
        FILE *fp = fopen(fname, "wt");
        FILE *fp_pos = fopen("pos.txt", "rt");

        fprintf(fp, "%d\n", 3);
        int n, m;
        for(n = 0; n < 3; n++)
        {
           int x1, y1, x2, y2;
           fscanf(fp_pos, "%d %d %d %d", &x1, &y1, &x2, &y2); 
           printf("%d %d %d %d\n", x1, y1, x2, y2);
           CvRect selection = cvRect(x1, y1, (x2 - x1 + 1), (y2 - y1 + 1));

           cvSetImageROI( red, selection );
           cvSetImageROI( mask, selection );
           cvCalcHist( &red, rhist, 0, mask );
           cvNormalizeHist( rhist, 0.333 );
           cvResetImageROI( red );
           cvResetImageROI( mask );

           cvSetImageROI( green, selection );
           cvSetImageROI( mask, selection );
           cvCalcHist( &green, ghist, 0, mask );
           cvNormalizeHist( ghist, 0.333 );
           cvResetImageROI( green );
           cvResetImageROI( mask );

           cvSetImageROI( blue, selection );
           cvSetImageROI( mask, selection );
           cvCalcHist( &blue, bhist, 0, mask );
           cvNormalizeHist( bhist, 0.333 );
           cvResetImageROI( blue );
           cvResetImageROI( mask );

           fprintf(fp, "%d %d %d %d ", x1, x2, y1, y2);

           for(m = 0; m < 24; m ++)
           {
               double hist_val = cvQueryHistValue_1D( rhist, m );
               fprintf(fp, "%f ", hist_val);
           }

           for(m = 0; m < 24; m ++)
           {
               double hist_val = cvQueryHistValue_1D( ghist, m );
               fprintf(fp, "%f ", hist_val);
           }

           for(m = 0; m < 16; m ++)
           {
               double hist_val = cvQueryHistValue_1D( bhist, m );
               fprintf(fp, "%f ", hist_val);
           }

           fprintf(fp, "\n");
          }

         fclose(fp);
         fclose(fp_pos);
         return 0;
}
   
