//////////////////////////////////////////////////////
// Camera Class
//////////////////////////////////////////////////////
// Hao Jiang
// March 2007, UBC
/////////////////////////////////////////////////////
//
// Current version supports Axis 206 network camera and
// video4linux video capturing card
//
///////////////////////////////////////////////////////

#include <stdarg.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/socket.h>
#include <resolv.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <cv.h>
#include <highgui.h>
#include <pthread.h>
#include "camera.h"

int NetworkCamera::init_cam(int &sockfd, char *addr, int width, int height)
{
    struct sockaddr_in dest;
    char line_buf[1024];

    if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0 )
    {  printf("Socket");
       return 2;
    }

    /*---Initialize server address/port struct---*/
    bzero(&dest, sizeof(dest));
    dest.sin_family = AF_INET;
    dest.sin_port = htons(80); /*default HTTP Server port */
    dest.sin_addr.s_addr = inet_addr(addr);

    /*---Connect to server---*/
    if ( connect(sockfd, (struct sockaddr*)&dest, sizeof(dest)) != 0 )
    {  printf("Connect");
       return 4;
    }

    char cmd[200];
    sprintf(cmd, "GET http://%s/axis-cgi/mjpg/video.cgi?resolution=%dx%d HTTP/1.0\n\n", addr, width, height);
    send(sockfd, cmd, strlen(cmd), 0);

    /*---While there's data, read it---*/
    readline(sockfd, line_buf, 1024);
    readline(sockfd, line_buf, 1024);
    readline(sockfd, line_buf, 1024);
    readline(sockfd, line_buf, 1024);
    readline(sockfd, line_buf, 1024);
    readline(sockfd, line_buf, 1024);
    readline(sockfd, line_buf, 1024);
    return 0;
}

int  NetworkCamera::readline(int fd, char* linebuf, int maxlength)
{
   int n;
   char c;
   for(n = 0; n < maxlength; n++)
   {
      int cn = recv(fd, &c, 1, 0);
      if (cn > 0)
         linebuf[n] = c;
      if (c == '\n')
         break;
    }
    return n;
} 

void  NetworkCamera::get_image(int sockfd, IplImage * image)
{
      char jpegname[100];
      char line_buf[1024];
      sprintf(jpegname, "v.jpg");
      FILE *fp = fopen(jpegname, "wb");
      readline(sockfd, line_buf, 1024);
      readline(sockfd, line_buf, 1024);
      readline(sockfd, line_buf, 1024);
      int filelen;
      char temp[500];
      sscanf(line_buf, "%s %d", temp, &filelen);
      readline(sockfd, line_buf, 1024);
      char buffer;

      for(int i = 0; i <= filelen + 1; i ++)
      {
        recv(sockfd, &buffer, sizeof(buffer), 0);
        fprintf(fp, "%c", buffer);
      }
      fclose(fp);
      IplImage *frame;
      frame = cvLoadImage("v.jpg");
      cvCopy(frame, image);
      cvReleaseImage(&frame);
}


