
#include <LEDA/graph_alg.h>
#include <LEDA/dictionary.h>
#include <LEDA/tuple.h>
#include <iostream.h>
#include <stdio.h>

int node_num[100][500];

#define HIST_BINS 64

float compare_hist(float hist1[], float hist2[], int dim)
{
   int n;
   float s = 0;
   for(n = 0; n < dim; n++)
   {
      s = s + fabs(hist1[n] - hist2[n]);
   }
   return s;
}
      
  
int main(int argn, char **argv)
{ 
  if ( argn < 3 )
  {  printf("Usgae: %s num_of_objects num_of_frames \n", argv[0]);
     exit(0);
  }
 
  int OBJ_NUM;
  sscanf(argv[1], "%d", &OBJ_NUM);
  int LAYERS;
  sscanf(argv[2], "%d", &LAYERS);

  dictionary< three_tuple<int, int, int>,  four_tuple<int, int, int, int> > index2xy;
  
  FILE *fp;
  int n, m, k;
  char fname[100];
  float histg[HIST_BINS];
  int object_num;
  
  for(object_num = 0; object_num < OBJ_NUM; object_num ++) {
  for(n = 1; n < LAYERS; n++)
  {
     sprintf(fname, "objects_info_h%d_%d.txt", object_num+1, n+1);
     fp = fopen(fname, "rt");
     fscanf(fp, "%d", &node_num[object_num][n]);
     for(m = 0; m <= node_num[object_num][n]; m++)
     {   int x1, y1, x2, y2;
         if (m < node_num[object_num][n]) {
           fscanf(fp, "%d %d %d %d", &x1, &x2, &y1, &y2);
           for(k = 0; k < HIST_BINS ; k++)
             fscanf(fp, "%f", &histg[k]);
         
           index2xy.insert(three_tuple<int, int, int>(object_num, n, m), 
                           four_tuple<int, int, int, int>(x1, y1, x2, y2));
           }
         else {
           x1 = 1; x2 = 2; y1 = 1; y2=2; 
           for(k = 0; k < HIST_BINS ; k++)
             histg[k] = 0;
           index2xy.insert(three_tuple<int, int, int>(object_num, n, m), 
                           four_tuple<int, int, int, int>(x1, y1, x2, y2));
           }         
     }
     fclose(fp);
   }
   }

  int object_num2, m2; 
  for(object_num = 0; object_num < OBJ_NUM; object_num ++) {
     for(n = 1; n < LAYERS; n++) {
        for(m = 0; m < node_num[object_num][n]; m++) {
            printf("%d %d %d ", object_num, n, m); 
            dic_item it1 = index2xy.lookup(three_tuple<int, int, int>(object_num, n, m));
            int x1 = index2xy[it1].first();
            int y1 = index2xy[it1].second();
            int x2 = index2xy[it1].third();
            int y2 = index2xy[it1].fourth();
            
            for(object_num2 = 0; object_num2 < OBJ_NUM; object_num2 ++) {
                 if (object_num2 == object_num)
                     continue;
                 for(m2 = 0; m2 < node_num[object_num2][n]; m2++) {
                      dic_item it2 = index2xy.lookup(three_tuple<int, int, int>(object_num2, n, m2));
                      int xx1 = index2xy[it2].first();
                      int yy1 = index2xy[it2].second();
                      int xx2 = index2xy[it2].third();
                      int yy2 = index2xy[it2].fourth();
                                            
                      if (fabs(x1-xx1) + fabs(y1-yy1) + fabs(x2-xx2) + fabs(y2-yy2) < 80)
                      //if (fabs(x1-xx1) + fabs(x2-xx2) < 50)
                          printf("%d %d ", object_num2, m2); 
                          //cout << object_num2 << " " << m2 << " ";
                 }
            } 
        printf("\n");
        }
     }
  }
  
 return 0;
}

  
