  
#include <LEDA/graph_alg.h>
#include <LEDA/dictionary.h>
#include <LEDA/tuple.h>
#include <iostream.h>
#include <stdio.h>

GRAPH<double,double> G;
char cline[100000];
int node_num[100][1000];

#define HIST_BINS 64
//#define LAYERS 20 
//#define OBJ_NUM 2

float compare_hist(float hist1[], float hist2[], int dim)
{
   int n;
   float s = 0;
   for(n = 0; n < dim; n++)
   {
      s = s + fabs(hist1[n] - hist2[n]);
   }
   return s;
}
      
  
int main(int argn, char **argv)
{ 
  if ( argn < 3 )
  {  printf("Usgae: %s num_of_objects num_of_frames \n", argv[0]);
     exit(0);
  }
 
  int OBJ_NUM;
  sscanf(argv[1], "%d", &OBJ_NUM);
  int LAYERS;
  sscanf(argv[2], "%d", &LAYERS);

  //int node_num[1000];
  edge e; node v;
  dictionary<three_tuple<int, int, int>, node> D;
  dictionary<node, four_tuple<int, int, int, int> > node2xy;
  dictionary<node, three_tuple<int, int, int> > node2index;
  
  FILE *fp;
  int n, m, k;
  char fname[100];  
  float histg[HIST_BINS];
  int object_num;
  
  for(object_num = 0; object_num < OBJ_NUM; object_num ++) {
  for(n = 0; n < LAYERS; n++)
  {
     sprintf(fname, "objects_info_h%d_%d.txt", object_num+1, n+1);
     fp = fopen(fname, "rt");
     fscanf(fp, "%d", &node_num[object_num][n]);
     for(m = 0; m <= node_num[object_num][n]; m++)
     {   int x1, y1, x2, y2;
         if (m < node_num[object_num][n]) {
           fscanf(fp, "%d %d %d %d", &x1, &x2, &y1, &y2);
           for(k = 0; k < HIST_BINS ; k++)
             fscanf(fp, "%f", &histg[k]);
         
           v = G.new_node();
           D.insert(three_tuple<int, int, int>(object_num, n, m), v);
           node2xy.insert(v, four_tuple<int, int, int, int>(x1, y1, x2, y2) );
           node2index.insert(v, three_tuple<int, int, int>(object_num, n, m) );           
           }
         else {
           x1 = 1; x2 = 2; y1 = 1; y2=2; 
           for(k = 0; k < HIST_BINS ; k++)
             histg[k] = 0;
           v = G.new_node();
           D.insert(three_tuple<int, int, int>(object_num, n, m), v);
           node2xy.insert(v, four_tuple<int, int, int, int>(x1, y1, x2, y2) ); 
           node2index.insert(v, three_tuple<int, int, int>(object_num, n, m) );           
           }         
     }
     fclose(fp);
   }
   }

  for(object_num = 0; object_num < OBJ_NUM; object_num ++) 
  {   node t = G.new_node();
      D.insert(three_tuple<int, int, int>(object_num, 500, 0), t);
      node2index.insert(t, three_tuple<int, int, int>(object_num, 500, 0));
  }
  
  char fname_next[100];  
  float histg_next[HIST_BINS];
  float histg_template[HIST_BINS];  
  float histg_template_arr[100][HIST_BINS];
  
  sprintf(fname, "objects_info_1.txt");
  fp = fopen(fname, "rt");
  int num;
  fscanf(fp, "%d", &num);
  for(m = 0; m <num ; m++) {
         int x1, y1, x2, y2;
         fscanf(fp, "%d %d %d %d", &x1, &x2, &y1, &y2);
         //dic_item it = D.lookup(two_tuple<int, int>(n, m));
         //node vv = D[it];
         for(k = 0; k < HIST_BINS ; k++)
             fscanf(fp, "%f", &histg[k]);
                
         for(k = 0; k < HIST_BINS ; k++)
             histg_template_arr[m][k] = histg[k]; }
  
  

  for(object_num = 0; object_num < OBJ_NUM; object_num ++) {
    for(n = 0; n < HIST_BINS; n++)
    {
        histg_template[n] = histg_template_arr[object_num][n];
    }
    dic_item it = D.lookup(three_tuple<int, int, int>(object_num, 500, 0));
    node t = D[it];
    
    for(n = 0; n < LAYERS; n++) {
     //cout << n << "\n";
     sprintf(fname, "objects_info_h%d_%d.txt", object_num+1, n+1);
     fp = fopen(fname, "rt");
     int num;
     fscanf(fp, "%d", &num);
     for(m = 0; m <= num; m++) {
         int x1, y1, x2, y2;
         node vv;
         node vv_next;
         if (m < num) {
             fscanf(fp, "%d %d %d %d", &x1, &x2, &y1, &y2);
             it = D.lookup(three_tuple<int, int, int>(object_num, n, m));
             vv = D[it];
             for(k = 0; k < HIST_BINS ; k++)
                fscanf(fp, "%f", &histg[k]);
         }
         else {
              dic_item it = D.lookup(three_tuple<int, int, int>(object_num, n, m));
              vv = D[it];
         }         

         if( n < LAYERS - 1) { 
            sprintf(fname_next, "objects_info_h%d_%d.txt", object_num+1, n+2);
            FILE *fp_next = fopen(fname_next, "rt");
            int num_next;
            fscanf(fp_next, "%d", &num_next);
            for(k = 0; k <= num_next; k++) {  
                //cout << k << "\n";
                int xx1, yy1, xx2, yy2;
                if (k < num_next) {
                  fscanf(fp_next, "%d %d %d %d", &xx1, &xx2, &yy1, &yy2);
                  it = D.lookup(three_tuple<int, int, int>(object_num, n+1, k));
                  vv_next = D[it];
                  e = G.new_edge(vv, vv_next);
                  for(int p = 0; p < HIST_BINS ; p++)
                      fscanf(fp_next, "%f", &histg_next[p]);
                   
                  if (m < num) {  
                     if (n == 0)
                        G[e] = compare_hist(histg, histg_next, HIST_BINS) * 1000 +
                               compare_hist(histg_next, histg_template, HIST_BINS) * 1000; 
                     else
                        G[e] = compare_hist(histg, histg_next, HIST_BINS) * 1000 +
                               compare_hist(histg_next, histg_template, HIST_BINS) * 1000 +
                               + 10 * fabs(xx1-x1) + 10 * fabs(yy1-y1);
                  } 
                  else {
                     G[e] = 1000; 
                     } }
                else {
                  it = D.lookup(three_tuple<int, int, int>(object_num, n+1, k));
                  vv_next = D[it];
                  e = G.new_edge(vv, vv_next);
                  G[e] = 1000; } 
             }
             fclose(fp_next);} 
          else {
            e = G.new_edge(vv, t);
            G[e] = 1; }     
         }
        fclose(fp);         
   }
   
  } 

  
int count = 0; 
forall_edges(e, G)
{
   count = count + 1;
}

cout << "Minimize\n";

for(object_num = 0; object_num < OBJ_NUM - 1; object_num ++) {
     for(n = 1; n < LAYERS - 1; n++) {
       cout << "0.001 p" << object_num << "," << n << " + " << "0.001 q" << object_num << "," << n << " + \n";
     }
}
         

int cn = 0;
forall_edges(e, G)
{
      cn = cn + 1;
	  node vv = G.source(e);
      dic_item it1 = node2index.lookup(vv);
	  node vv_next = G.target(e);
      dic_item it2 = node2index.lookup(vv_next);
      if (cn < count) {
     	     cout << G[e] << " x" << node2index[it1].first()  << "," << node2index[it1].second() << "," << node2index[it1].third() << "," 
	              << node2index[it2].third() << " + \n";  }
	  else {
     	     cout << G[e] << " x" << node2index[it1].first()  << "," << node2index[it1].second() << "," << node2index[it1].third() << "," 
	              << node2index[it2].third() << " \n"; 
            }
}  

int num_vars = count;

cout << "\nSubject To \n";

//it = D.lookup(three_tuple<int, int, int>(0,0,1));
//node v_remove = D[it];

for(object_num = 0; object_num < OBJ_NUM; object_num ++) {
 dic_item it = D.lookup(three_tuple<int, int, int>(object_num, 0, object_num));
 node s = D[it];
 it = D.lookup(three_tuple<int, int, int>(object_num, 500, 0));
 node t = D[it];

 forall_nodes(v, G)
 {
   if (v == s)
   {
          int cn = 1;
          forall_out_edges(e, s)  {
              dic_item it1 = node2index.lookup(s);
         	  node vv_next = G.target(e);
              dic_item it2 = node2index.lookup(vv_next);
              if ( cn == G.outdeg(s)) 
                   cout  << " x" << node2index[it1].first()  << "," << node2index[it1].second() << "," << node2index[it1].third() << "," 
                         << node2index[it2].third() << " = 1 \n";        	  
	          else 
                   cout  << " x" << node2index[it1].first()  << "," << node2index[it1].second() << "," << node2index[it1].third() << ","
                         << node2index[it2].third() << " + \n";        	  
	          cn ++;            
	       }
	}
 
 if (v == t)	
 {
         int cn = 1;
         forall_in_edges(e, t)  {
              dic_item it2 = node2index.lookup(t);
         	  node vv = G.source(e);
              dic_item it1 = node2index.lookup(vv);
              if ( cn == G.indeg(t)) 
                     cout  << " x" << node2index[it1].first()  << "," << node2index[it1].second() << "," << node2index[it1].third() << ","
                           << node2index[it2].third() << " = 1 \n";        	  
	          else 
                     cout  << " x" << node2index[it1].first()  << "," << node2index[it1].second() << "," << node2index[it1].third() << ","
                           << node2index[it2].third() << " + \n";        	  
	          cn ++;                
	       }
	} 
	  
 it = node2index.lookup(v);
 if (v != t && v != s && node2index[it].first() == object_num && node2index[it].second() > 0) {
	      int cn = 1;
          forall_out_edges(e, v)  {
              dic_item it1 = node2index.lookup(v);
         	  node vv_next = G.target(e);
              dic_item it2 = node2index.lookup(vv_next);
              if ( cn == G.outdeg(v)) {
                     cout  << " x" << node2index[it1].first()  << "," << node2index[it1].second() << "," << node2index[it1].third() << ","
                           << node2index[it2].third() << " - \n";     }   	  
	          else {
                     cout  << " x" << node2index[it1].first()  << "," << node2index[it1].second() << "," << node2index[it1].third() << ","
                           << node2index[it2].third() << " + \n";    }    	  
	          cn ++;            
	       }

	      cn = 1;
          forall_in_edges(e, v)  {
              dic_item it1 = node2index.lookup(v);
         	  node vv_next = G.source(e);
              dic_item it2 = node2index.lookup(vv_next);
              if ( cn == G.indeg(v)) 
                     cout  << " x" << node2index[it2].first()  << "," << node2index[it2].second() << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " = 0 \n";        	  
              else             
                     cout  << " x" << node2index[it2].first()  << "," << node2index[it2].second() << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " - \n";        	  
	          cn ++;            
	       }
	} 
   
 }
}
      
ifstream infile("ttt.txt");
//ofstream outfile("mytest.txt");

while(!infile.eof())
{
   int obj_n, layer_n, pos_n;
   infile.getline(cline, 100000);
   int obj_n2, pos_n2;
   char *ps = cline;
   char ss[10];
   int word_count1 = 0;

   while(*ps != '\0')
  {
       while(*ps == ' ') ps++;
       int cnn = 0;
       while(*ps != ' ' && *ps != '\0')
       {
            ss[cnn] = *ps;
            cnn++;
            ps++;
       }
       ss[cnn] = '\0';
       word_count1 ++;
       if (word_count1 == 1)
           obj_n = atoi(ss);
       if (word_count1 == 2)
           layer_n = atoi(ss);
       if (word_count1 == 3)
           pos_n = atoi(ss);

   }

   if(word_count1 > 4 ) {
      dic_item it = D.lookup(three_tuple<int, int, int>(obj_n, layer_n, pos_n));
      node v = D[it];
      forall_in_edges(e, v)  {
        dic_item it1 = node2index.lookup(v);
        node vv_from = G.source(e);
        dic_item it2 = node2index.lookup(vv_from);
        cout  << " x" << node2index[it2].first()  
              << "," << node2index[it2].second() 
              << "," << node2index[it2].third() << ","
              << node2index[it1].third() << " + \n";
      }  
      
  //   outfile << "\n" << obj_n << " " << layer_n << " " << pos_n << "\n";
   }

   //outfile << word_count1 << "\n";
    
   int word_count = 0;
   ps = cline;
   while(*ps != '\0')
  {
       while(*ps == ' ') ps++;
       int cnn = 0;
       while(*ps != ' ' && *ps != '\0')
       {
            ss[cnn] = *ps;
            cnn++;
            ps++;
       }
       ss[cnn] = '\0';
       word_count ++;
       if (word_count == 1)
           obj_n = atoi(ss);
       if (word_count == 2)
           layer_n = atoi(ss);
       if (word_count == 3)
           pos_n = atoi(ss);

       if(word_count > 3 && (word_count - 3) % 2 == 1)
           obj_n2 = atoi(ss);
       if(word_count > 3 && (word_count - 3) % 2 == 0)
           pos_n2 = atoi(ss);

       if(word_count > 3 && layer_n >= 1 && (word_count - 3) % 2 == 0) {           
          dic_item it = D.lookup(three_tuple<int, int, int>(obj_n2, layer_n, pos_n2));
          node v = D[it];
          cn = 1;
          forall_in_edges(e, v)  {
              dic_item it1 = node2index.lookup(v);
              node vv_from = G.source(e);
              dic_item it2 = node2index.lookup(vv_from);
              if ( cn == G.indeg(v) && word_count == word_count1 - 1) 
                     cout  << " x" << node2index[it2].first()  << "," 
                           << node2index[it2].second() << "," 
                           << node2index[it2].third() << ","
                           << node2index[it1].third() << " <= 1 \n";        	  
              else             
                     cout  << " x" << node2index[it2].first()  << "," 
                           << node2index[it2].second() << "," 
                           << node2index[it2].third() << ","
                           << node2index[it1].third() << " + \n";        	  
	          cn ++;            
           }
    //       outfile << obj_n2 << " " << pos_n2 << ", ";

        }
   }        
 //outfile << cline;
 //outfile << "\n";     
} 
       
  for(object_num = 0; object_num < OBJ_NUM; object_num ++) {
  for(n = 1; n < LAYERS; n++)
  {
     for(m = 0; m <= node_num[object_num][n]; m++)
     {   
         dic_item it = D.lookup(three_tuple<int, int, int>(object_num, n, m));
         node v = D[it];
         int x1, y1, x2, y2;
         it = node2xy.lookup(v);
         x1 = node2xy[it].first();
         y1 = node2xy[it].second();
         x2 = node2xy[it].third();
         y2 = node2xy[it].fourth();

         int cn = 1;
         forall_in_edges(e, v)  {
              node vv_from = G.source(e);
              dic_item it2 = node2index.lookup(vv_from);
              dic_item it1 = node2index.lookup(v);
              if ( cn == G.indeg(v) && m == node_num[object_num][n]) 
                     cout  << x1 << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() 
                           << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " - a" 
                           << object_num << "," << n << " = 0 \n";        	  
              else             
                     cout  << x1 << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() 
                           << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " + \n";        	  
	          cn ++;            
           }
         
     }
     
     for(m = 0; m <= node_num[object_num][n]; m++)
     {   
         dic_item it = D.lookup(three_tuple<int, int, int>(object_num, n, m));
         node v = D[it];
         int x1, y1, x2, y2;
         it = node2xy.lookup(v);
         x1 = node2xy[it].first();
         y1 = node2xy[it].second();
         x2 = node2xy[it].third();
         y2 = node2xy[it].fourth();

         int cn = 1;
         forall_in_edges(e, v)  {
              node vv_from = G.source(e);
              dic_item it2 = node2index.lookup(vv_from);
              dic_item it1 = node2index.lookup(v);
              if ( cn == G.indeg(v) && m == node_num[object_num][n]) 
                     cout  << x2 << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() 
                           << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " - b" 
                           << object_num << "," << n << " = 0 \n";        	  
              else             
                     cout  << x2 << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() 
                           << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " + \n";        	  
	          cn ++;            
           }
         
     }

     for(m = 0; m <= node_num[object_num][n]; m++)
     {   
         dic_item it = D.lookup(three_tuple<int, int, int>(object_num, n, m));
         node v = D[it];
         int x1, y1, x2, y2;
         it = node2xy.lookup(v);
         x1 = node2xy[it].first();
         y1 = node2xy[it].second();
         x2 = node2xy[it].third();
         y2 = node2xy[it].fourth();

         int cn = 1;
         forall_in_edges(e, v)  {
              node vv_from = G.source(e);
              dic_item it2 = node2index.lookup(vv_from);
              dic_item it1 = node2index.lookup(v);
              if ( cn == G.indeg(v) && m == node_num[object_num][n]) 
                     cout  << y1 << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() 
                           << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " - c" 
                           << object_num << "," << n << " = 0 \n";        	  
              else             
                     cout  << y1 << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() << "," 
                           << node2index[it2].third() << ","
                           << node2index[it1].third() << " + \n";        	  
	          cn ++;            
           }
         
     }


     for(m = 0; m <= node_num[object_num][n]; m++)
     {   
         dic_item it = D.lookup(three_tuple<int, int, int>(object_num, n, m));
         node v = D[it];
         int x1, y1, x2, y2;
         it = node2xy.lookup(v);
         x1 = node2xy[it].first();
         y1 = node2xy[it].second();
         x2 = node2xy[it].third();
         y2 = node2xy[it].fourth();

         int cn = 1;
         forall_in_edges(e, v)  {
              node vv_from = G.source(e);
              dic_item it2 = node2index.lookup(vv_from);
              dic_item it1 = node2index.lookup(v);
              if ( cn == G.indeg(v) && m == node_num[object_num][n]) 
                     cout  << y2 << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() 
                           << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " - d" 
                           << object_num << "," << n << " = 0 \n";        	  
              else             
                     cout  << y2 << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() 
                           << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " + \n";        	  
	      cn ++;            
           }
         
     }
     
     dic_item it = D.lookup(three_tuple<int, int, int>(object_num, n, node_num[object_num][n]));
     node v = D[it];
     int cn = 1;
     forall_in_edges(e, v)  {
              node vv_from = G.source(e);
              dic_item it2 = node2index.lookup(vv_from);
              dic_item it1 = node2index.lookup(v);
              if ( cn == G.indeg(v) ) 
                     cout  << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() 
                           << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " - z" 
                           << object_num << "," << n << " = 0 \n";        	  
              else             
                     cout  << " x" << node2index[it2].first()  
                           << "," << node2index[it2].second() 
                           << "," << node2index[it2].third() << ","
                           << node2index[it1].third() << " + \n";        	  
	          cn ++;            
     }
     
    
     for(m = 0; m <= node_num[object_num][n]; m++)
     {
         dic_item it = D.lookup(three_tuple<int, int, int>(object_num, n, m));
         node v = D[it];

         int cn = 1;
         forall_in_edges(e, v)  {
              node vv_from = G.source(e);
              dic_item it2 = node2index.lookup(vv_from);
              dic_item it1 = node2index.lookup(v);
              if ( cn == G.indeg(v) )
                     cout  << "x" << node2index[it2].first()  << ","
                           << node2index[it2].second() << ","
                           << node2index[it2].third() << ","
                           << node2index[it1].third() << " - v"
                           << object_num << "," << n << "," << m << " = 0 \n";
              else
                     cout  << "x" << node2index[it2].first()  << ","
                           << node2index[it2].second() << ","
                           << node2index[it2].third() << ","
                           << node2index[it1].third() << " + \n";
                  cn ++;
           }

     }
 
   }
  }

  for(object_num = 0; object_num < OBJ_NUM - 1; object_num ++) {
  for(n = 1; n < LAYERS - 1; n++)
  {
      cout << "a" << object_num << "," << n << " - " << "y" << object_num << "," << n + 1 << " - " 
           << "a" << object_num + 1 << "," << n << " + " << "y" << object_num + 1 << "," << n + 1 << " - "
           << "p" << object_num << "," << n << " + " << "q" << object_num << "," << n << " = 0 \n";
  } 
  }       
  
/*cout << "\nBinaries\n";
cn = 0;
forall_edges(e, G)
{
      cn = cn + 1;
      node vv = G.source(e);
      dic_item it1 = node2index.lookup(vv);
      node vv_next = G.target(e);
      dic_item it2 = node2index.lookup(vv_next);
      cout <<  " x" << node2index[it1].first()  << "," << node2index[it1].second() << "," << node2index[it1].third() << ","
           << node2index[it2].third() << " \n";  
}*/

cout << "\nEnd";

  return 0;
}

  
